
/*
 * Trust Design LLC : SECS/HSMS Communication library
 *
 * (c) Copyright Trust Design LLC.  2010-2018.  All rights reserved.
 */


/* ========================================================================== */
/*
 * JavaIo : テスト 及び サンプル・プログラム
 *
 * JNA を使用せず（従って TDS.dll を使用せず）TDS.jar のみを使用した純 Java
 * 環境ので動作で Callback 関数を使用して受信メッセージに対する応答処理を行う。
 *
 *
 * 起動方法
 *
 *   java JavaIo {h|e}
 *   ~~~~~~~~~~~~~~~~~
 *   h    : Sample.ini の [HOST]  セクションを参照し動作を決定する
 *   e    : Sample.ini の [EQUIP]      :              :
 *
 *
 *   通常、JavaIo h 及び JavaIo e の両方を、同一マシン、もしくは異なるマシン上
 *   で動作させて、相互通信を行う。通信相手は、BasicIo.exe、Callbackio.exe でも
 *   よい。
 *
 *   起動後、メニュ表示を参照し、要求コード等を入力し、機能を実行する。
 * 
 *   ホスト側は起動すると、装置側からの接続を待つ。装置側を起動すると、自動的
 *   にホスト側に接続要求、Select 要求を発行する。ホスト側では、1:Recv 処理を
 *   繰り返し行い、表示が「STATUS=951 : No data」となるのを確認する。その後、
 *   任意のメッセージのやりとりを行う。受信側では、受信データの刈り取りを「
 *   STATUS=951」になるまで行うことを忘れぬこと。
 *
 *   ２次メッセージを送信する際のトランザクションＩＤは、直前に受信した１次
 *   メッセージのものを使用する。
 *
 *   本サンプルは、異常時処理を一部省略している。
 *
 *   以下で定義する "SECS_MODE" は、処理関数として _TDSCommXxxx() を使用する
 *   場合で Active 接続の場合の Passive 側への接続処理の実行の有無を判断する
 *   ために定義する。
 *   "FUNC_TYPE" は、使用する処理関数の種別を選択するために定義する。
 *   _TDSUDrvXxxx() を使用する場合は、HSMS-SS Active 接続の場合の接続処理を
 *   行う必要がないので、本来であれば "SECS_MODE" の設定も必要がない。
 *   TDS は、SECS-1 接続 or HSMS-SS 接続の切替は、設定ファイル (.ini) にて行う
 *   ため、処理関数として _TDSUDrvXxxx() を使用する限りは、ユーザＡＰでは、
 *   接続方式（SECS-1/HSMS-SS そして HSMS-SS時の Passive/Active）を知る必要は
 *   ない。
 *
 *   以下で定義する "MSSG_USE_FILE"、"MSSG_DISP_TYPE" の値を変更すると、本ＡＰ
 *   にて表示する SECS メッセージの出力形式を変更できる。
 *   "MSSG_USE_NEXTL" の値を変更すると、メッセージ内容を解析する際に、項目値を
 *   データとして取得するか、表示リスト形式で取得するかを変更できる。
 *   同様に "USE_CALLBACK" を =1 とすると、受信処理を行う Callback 関数を使用
 *   し、受信メッセージの表示、２次メッセージの出力を自動で行う。
 *   Callback 関数を使用する場合、入力促進用メッセージに乱れが生じる事に留意
 *   すること。
 */
/* ========================================================================== */

import		java.lang.*;
import		java.util.*;
import		java.io.*;
import		java.nio.*;

import 		TDL.TDS.TDSComm;
import 		TDL.TDS.TDSUDrv;
import 		TDL.TDS.TDSMssg;


public class	JavaIo{


/* -------------------------------------------------------------------------- */

static final int	EBADF		=9;
static final int	EBUSY		=16;
static final int	ENOMEM		=12;
static final int	ENODEV		=19;
static final int	E2BIG		=7;

static final int	E_NOTCONNECT	=999;
static final int	E_DESELECT	=998;
static final int	E_REJECT	=997;
static final int	E_SELECT	=992;
static final int	E_CONNECT	=991;
static final int	E_RETRYOVER	=989;
static final int	E_T8TIMEDOUT	=988;
static final int	E_T7TIMEDOUT	=987;
static final int	E_T6TIMEDOUT	=986;
static final int	E_T5TIMEDOUT	=985;
static final int	E_T4TIMEDOUT	=984;
static final int	E_T3TIMEDOUT	=983;
static final int	E_T2TIMEDOUT	=982;
static final int	E_T1TIMEDOUT	=981;
static final int	E_ILLBLOCK	=980;
static final int	E_NODATA	=951;


/* -------------------------------------------------------------------------- */

static final int	SECS_MODE	=1;	// SECS/HSMS モード
						// 0    : SECS-1
						// 1    : HSMS
static final int	FUNC_TYPE	=0;	// 通信に使用する関数の種別
						// 0    : _TDSCommXxxxx
						// 1    : _TDSUDrvXxxxx
static final int	UDRV_MASK  =0x8383ffff;	// UDrvOpen() に使用するマスク
						// 0 の場合 0x49 となる。
						// 0x8383ffff は全ての EVENT

static final int	USE_CALLBACK	=1;	// Callback 関数使用の有無
						// 0    : 使用しない
						// 1    : 使用する

static final int	MSSG_DISP_TYPE	=0x20;	// SECS メッセージ表示形式
						// 0x00 : 通常形式
						// 0x10 : ????形式
						// 0x20 : SML 形式
						// 0x40 : NSG/TS300 形式
static final int	MSSG_USE_NEXTL	=1;	// MssgNextL を使用するか否か
						// 0    : 使用しない
						// 1    : 使用する

static final String	PARAMFILE	="Sample.ini";


/* -------------------------------------------------------------------------- */

static TDSComm		SAcb;		// SECS 通信クラス
static TDSUDrv		UAcb;		// SECS 通信クラス
static int		Break=0;	// スレッド終了指示
static int		OType=0;	// 動作タイプ (0:Host 1:Equip)

static int		cnt249=0;
static int		cnt250=0;
static int		cnt611=0;


/* ========================================================================== */
/* 共通関数 ================================================================= */

static private void
printf(
String		form,
Object...	arg)
{
  try{
    System.out.printf(form,arg);
  }catch(UnknownFormatConversionException	err){
    System.out.printf("Format error\n");
  }catch(Exception				err){
    System.out.printf("Printf error\n");
  }
}


/* -------------------------------------------------------------------------- */

static private void
Sleep(
int		msec)
{
  try{
    Thread.sleep((long)msec);
  }catch(InterruptedException	err){
  }catch(Exception		err){
  }finally{
  }
}


/* -------------------------------------------------------------------------- */

static private String
ReadLine(			//  o : 入力文字列
BufferedReader	in,		// i  : 入力記述子
String		msg)		// i  : 入力促進メッセージ
{
  String	line;

  for(;;){
    printf("%s"	,msg);
    try{			line=in.readLine();
    }catch(Exception		err){			continue;
    }							break;
  }

  return(line);
}


static private int
ReadInt(			//  o : 入力値
BufferedReader	in,		// i  : 入力記述子
String		msg,		// i  : 入力促進メッセージ
int		base)		// i  : 整数基数
{
  String	line;
  int		val;

  for(;;){
    line=ReadLine(in,msg);
    try{			val=Integer.parseInt(line,base);
    }catch(Exception		err){			continue;
    }							break;
  }

  return(val);
}


/* -------------------------------------------------------------------------- */
/* SECS メッセージを標準出力に表示する。 ------------------------------------ */

static private void
DispSECSMssg(			//
int		tp,		// i  : メッセージ種別
				//	=0 : 送信結果
				//	 1 : 受信メッセージ
				//	 2 : 送信メッセージ
byte		hd[],		// i  : SECS メッセージ・ヘッダ
int		did,		// i  : SECS メッセージのデバイスＩＤ
int		sf,		// i  : SECS メッセージのＳＦコード
int		xid,		// i  : SECS メッセージのトランザクションＩＤ
byte		msg[],		// i  : SECS メッセージ格納領域（ヘッダ含まず）
int		len)		// i  : SECS メッセージのバイト長
{
  String	ctp[]={"SRES","RECV","SEND"};
  String	rbit,wbit,sfcode,c;
  StringBuffer	mname=new StringBuffer(),sitem=new StringBuffer();
  ByteBuffer	pm;
  TDSMssg	mcb=new TDSMssg();
  byte		msg1[];
  long		ul;
  int		form[]=new int[1],sz[]=new int[1],noi[]=new int[1];
  int		rtn,md=0,dp=MSSG_DISP_TYPE,fm=0,la,i,j;

  rbit=" ";	if((did&0x8000)!=0)	rbit="R";
  wbit=" ";	if((sf &0x8000)!=0)	wbit="W";
  sfcode=String.format("S%dF%d",(sf&0x7f00)/0x0100,sf&0xff);
  printf("[%s]  Dev=0x%04x  %-8s  %s%s  XId=0x%04x  Len=%4d\n"
		,ctp[tp],did&0x7fff,sfcode,rbit,wbit,xid,len);

  if(len>0){
    if(tp==1){	dp|=0x3000;	fm|=0x3000;}		// 受信の場合
    else{	dp|=0x2000;	fm|=0x2000;}		// 送信の場合
    pm=ByteBuffer.allocate(1024);	pm.order(ByteOrder.nativeOrder());
    msg1=pm.array();

    if(mcb._TDSMssgFind(fm,msg,len,0,hd)		>=0){
      for(la=0;;){
	if(MSSG_USE_NEXTL==0){				// 項目値を取得
	  rtn=mcb._TDSMssgNext(0,msg,form,sz,noi,pm,1024);
	  if(rtn						< 0)	break;
	  printf("%03o:%d*%3d:"	,form[0],sz[0],noi[0]);
	  switch(form[0]){
	    case 000: printf("L[%d]\n"	,noi[0]);		break;
	    case 010: printf("B[%d]"	,noi[0]);
		      for(c="=",i=0;i<noi[0];i++){
		        printf("%s0x%02x"
				,c,((int)msg1[i]&0xff));	if(i==0) c=",";
		      } printf("\n");				break; 
	    case 011: printf("T[%d]"	,noi[0]);
		      for(c="=",i=0;i<noi[0];i++){
		        printf("%s%d"	,c,msg1[i]);		if(i==0) c=",";
		      } printf("\n");				break; 
	    case 020: c=new String(msg1,0 ,noi[0]);
		      printf("A[%d]=%s.\n",noi[0],c);	c=null;	break;
	    case 021: c=new String(msg1,0 ,noi[0]);
		      printf("J[%d]=%s.\n",noi[0],c);	c=null;	break;
	    case 022: c=new String(msg1,0 ,noi[0]);
		      printf("K[%d]=%s.\n",noi[0],c);	c=null;	break;
	    case 030: printf("I8[%d]"	,noi[0]);
		      for(c="=",i=0;i<noi[0];i++){
		        printf("%s%d"	,c,pm.getLong	(i*8));	if(i==0) c=",";
		      } printf("\n");				break;
	    case 031: printf("I1[%d]"	,noi[0]);
		      for(c="=",i=0;i<noi[0];i++){
		        printf("%s%d"	,c,msg1[i]);		if(i==0) c=",";
		      } printf("\n");				break; 
	    case 032: printf("I2[%d]"	,noi[0]);
		      for(c="=",i=0;i<noi[0];i++){
		        printf("%s%d"
				,c,(int)pm.getShort	(i*2));	if(i==0) c=",";
		      } printf("\n");				break; 
	    case 034: printf("I4[%d]"	,noi[0]);
		      for(c="=",i=0;i<noi[0];i++){
		        printf("%s%d"	,c,pm.getInt	(i*4));	if(i==0) c=",";
		      } printf("\n");				break; 
	    case 040: printf("F8[%d]"	,noi[0]);
		      for(c="=",i=0;i<noi[0];i++){
		        printf("%s%22.17e"
				,c,pm.getDouble		(i*8));	if(i==0) c=",";
		      } printf("\n");				break; 
	    case 044: printf("F4[%d]"	,noi[0]);
		      for(c="=",i=0;i<noi[0];i++){
		        printf("%s%13.8e",c,pm.getFloat	(i*4));	if(i==0) c=",";
		      } printf("\n");				break; 
	    case 050: printf("U8[%d]"	,noi[0]);
		      for(c="=",i=0;i<noi[0];i++){
			printf("%s%d"	,c,pm.getLong	(i*8));	if(i==0) c=",";
		      } printf("\n");				break;
	    case 051: printf("U1[%d]"	,noi[0]);
		      for(c="=",i=0;i<noi[0];i++){
			ul=((long)msg1[i])&0xffL;
		        printf("%s%d"	,c,ul);			if(i==0) c=",";
		      } printf("\n");				break; 
	    case 052: printf("U2[%d]"	,noi[0]);
		      for(c="=",i=0;i<noi[0];i++){
			ul=((long)pm.getShort(i*2))&0xffffL;
		        printf("%s%d"	,c,ul);			if(i==0) c=",";
		      } printf("\n");				break; 
	    case 054: printf("U4[%d]"		,noi[0]);
		      for(c="=",i=0;i<noi[0];i++){
			ul=((long)pm.getInt  (i*4))&0xffffffffL;
		        printf("%s%d"	,c,ul);			if(i==0) c=",";
		      } printf("\n");				break; 
	    default:  printf("\n");				break;
	  }

	}else{						// リスト表示形式で取得
	  rtn=mcb._TDSMssgNextL(dp,msg,form,noi,mname);
	  if(rtn						< 0)	break;
	  if((dp&0x70)>0x10){				// SML、NSG/TS300 の場合
	    for(  i=la;i>rtn;i--){
	      for(j= 0;j<i  ;j++) printf("  ");
	      printf(">\n");				// '>' 表示
	  } }
	  la=rtn;					// 現在の階層を保存
	  printf("  %s\n",mname.toString());		// 取得した項目値を表示
	  if((dp&0x70)>0x10 && form[0]==000 && noi[0]==0){
	    for(  j= 0;j<=la;j++) printf("  ");
	    printf(">\n");				// L0 の場合の '>' 処理
      } } }
      if(MSSG_USE_NEXTL!=0){
	if((dp&0x70)>0x10){
	  for(  i=la;i>0;i--){
	    for(j= 0;j<i;j++)	  printf("  ");
	    printf(">\n");				// 残りの '>' 表示
      } } }
      mcb._TDSMssgExit(0,msg);
  } }

  mcb=null;
}



/* -------------------------------------------------------------------------- */
/* 送受信データを表示する。-------------------------------------------------- */

static private int
DispData(
int		tp,		// i  : メッセージ種別
				//	=0 : 送信結果
				//	 1 : 受信メッセージ
				//	 2 : 送信メッセージ
byte		hd[],		// i  : SECS メッセージ・ヘッダ
int		did,		// i  : SECS メッセージのデバイスＩＤ
int		sf,		// i  : SECS メッセージのＳＦコード
int		xid,		// i  : SECS メッセージのトランザクションＩＤ
byte		msg[],		// i  : SECS メッセージ本体
int		len,		// i  : msg の長さ
int		rtn)		// i  : I/O の戻り値
{
  int		ok=0;

  if(rtn<0){							 ok=1;
    if((rtn<(-E_NOTCONNECT) || (-E_ILLBLOCK)<rtn) && rtn!=(-E_NODATA)){
      printf("ERROR  [%d]"			,rtn);
      if      (rtn==(-ENODEV)){
	printf(" : No such device ID\n");	len=ok=0;
      }else if(rtn==(-E2BIG )){
	printf(" : Data size to large\n");	len=ok=0;
      }else			printf("\n");
    }else{
      if(FUNC_TYPE==0)	printf("STATUS = %d,%d : ",-rtn,SAcb._TDSCommStatus(0));
      else		printf("STATUS = %d,%d : ",-rtn,UAcb._TDSUDrvStatus(0));
      switch(-rtn){
	case E_NODATA:		printf("No data\n");			break;
	case E_ILLBLOCK:	printf("Illegal block#\n");		break;
	case E_T1TIMEDOUT:	printf("T1 Timeout occur\n");		break;
	case E_T2TIMEDOUT:	printf("T2 Timeout occur\n");		break;
	case E_T3TIMEDOUT:	printf("T3 Timeout occur\n");		break;
	case E_T4TIMEDOUT:	printf("T4 Timeout occur\n");		break;
	case E_T5TIMEDOUT:	printf("T5 Timeout occur\n");		break;
	case E_T6TIMEDOUT:	printf("T6 Timeout occur\n");		break;
	case E_T7TIMEDOUT:	printf("T7 Timeout occur\n");		break;
	case E_T8TIMEDOUT:	printf("T8 Timeout occur\n");		break;
	case E_RETRYOVER:	printf("Retry over\n");			break;
	case E_CONNECT:		printf("Connected\n");			break;
	case E_SELECT:		printf("Selected\n");			break;
	case E_REJECT:		printf("Rejected XId=0x%04x\n",xid);	break;
	case E_DESELECT:	printf("Deselected\n");			break;
	case E_NOTCONNECT:	printf("Not connected\n");		break;
	default:		printf("\n");				break;
  } } }

  if(ok==0) DispSECSMssg(tp,hd,did,sf,xid,msg,len);

  return(0);
}



/* ========================================================================== */
/* S1F1 メッセージ構築及び送信 ---------------------------------------------- */

static private int
SendS1F1()
{
  byte		hd[]=new byte[12],msg[]=new byte[16];
  int		rtn,sf=0x8101,len=0;

  if(FUNC_TYPE	==0)	rtn=SAcb._TDSCommSend(0x0000,0,sf,  0,msg,len,hd);
  else			rtn=UAcb._TDSUDrvSend(0x0000,0,sf,  0,msg,len,hd);
  DispData(2,hd,0x00,sf,rtn,msg,len,rtn);

  return(rtn);
}


/* ---------------------------------------------------------------------------*/
/* S1F2 メッセージ (Host) 構築及び送信 -------------------------------------- */

static private int
SendS1F2H(
int		did,
int		xid)
{
  TDSMssg	mcb =new TDSMssg();
  byte		hd[]=new byte[12],msg[]=new byte[256];
  int		rtn,sf=0x0102,len;
  
  		mcb._TDSMssgInit   (0,msg, 256);		// S1F2
		mcb._TDSMssgBuild  (0,msg, 000,  0);		// L0
  len=		mcb._TDSMssgEnd    (0,msg);

  if(len<0)	rtn=len;
  else{
    if(FUNC_TYPE==0)	rtn=SAcb._TDSCommSend(0x0000,did,sf,xid,msg,len,hd);
    else		rtn=UAcb._TDSUDrvSend(0x0000,did,sf,xid,msg,len,hd);
  }
  DispData(2,hd,did,sf,rtn,msg,len,rtn);
  mcb=null;

  return(rtn);
}


/* ---------------------------------------------------------------------------*/
/* S1F2 メッセージ (Equip) 構築及び送信 ------------------------------------- */

static private int
SendS1F2E(
int		did,
int		xid)
{
  TDSMssg	mcb =new TDSMssg();
  byte		hd[]=new byte[12],msg[]=new byte[256];
  int		rtn,sf=0x0102,len;
  
    		mcb._TDSMssgInit   (0,msg, 256);		// S1F2
		mcb._TDSMssgBuild  (0,msg, 000, 2);		// L2
		mcb._TDSMssgBuild  (0,msg, 020, 6,"EQUIP1");	//  MDLN
		mcb._TDSMssgBuild  (0,msg, 020, 6,"01.000");	//  SOFTREV
  len=		mcb._TDSMssgEnd    (0,msg);

  if(len<0)	rtn=len;
  else{
    if(FUNC_TYPE==0)	rtn=SAcb._TDSCommSend(0x0000,did,sf,xid,msg,len,hd);
    else		rtn=UAcb._TDSUDrvSend(0x0000,did,sf,xid,msg,len,hd);
  }
  DispData(2,hd,did,sf,rtn,msg,len,rtn);
  mcb=null;

  return(rtn);
}


/* ========================================================================== */
/* S2F49 メッセージ構築及び送信 --------------------------------------------- */

static private int
SendS2F49()
{
  TDSMssg	mcb =new TDSMssg();
  byte		hd[]=new byte[12],msg[]=new byte[1024];
  byte		vb[]=new byte[32];
  int		vi[]=new int[4];
  String	str,itm;
  int		rtn,sf=0x8200+49,no1,no2,len,i,j;

  cnt249++;	no1=(cnt249%2)+1;	no2=(cnt249%10)+1;
  str=String.format("LOTID (%04d)"	,cnt249);
  
		mcb._TDSMssgInit   (0,msg,1024);		// S2F49
  		mcb._TDSMssgBuild  (0,msg, 000,  3);		// L3
  vb[0]=0;	mcb._TDSMssgBuild  (0,msg, 010,  1,vb);		//  DATAIDB
  		mcb._TDSMssgBuild  (0,msg, 020,  0,"LOAD");	//  RCMD
  		mcb._TDSMssgBuild  (0,msg, 000,  4);		//  L4
  vb[0]=1;	mcb._TDSMssgBuild  (0,msg, 010,  1,vb);		//   STID
  vb[0]=0;	mcb._TDSMssgBuild  (0,msg, 010,  1,vb);		//   MTKD
  		mcb._TDSMssgBuild  (0,msg, 020, 20,str);	//   LOTID
		mcb._TDSMssgBuild  (0,msg, 000,no1);		//   L[no1]
  for(i=0;i<no1;i++){
		mcb._TDSMssgBuild  (0,msg, 000,no2);		//    L[no2]
    for(j=0;j<no2;j++){
		mcb._TDSMssgBuild  (0,msg, 000,  2);		//     L[2]
      str=String.format("WAFER(%04d-%d-%02d)",cnt249,i+1,i+2);
  		mcb._TDSMssgBuild  (0,msg, 020, 20,str);	//      WAFERID
      str=String.format("PPID (%04d-%d-%02d)",cnt249,i+1,i+2);
  		mcb._TDSMssgBuild  (0,msg, 020, 16,str);	//      PPID
  } }
  len=		mcb._TDSMssgEnd    (0,msg);

  if(len<0)	rtn=len;
  else{
    if(FUNC_TYPE==0)	rtn=SAcb._TDSCommSend(0x0000,0,sf,  0,msg,len,hd);
    else		rtn=UAcb._TDSUDrvSend(0x0000,0,sf,  0,msg,len,hd);
  }
  DispData(2,hd,0x00,sf,rtn,msg,len,rtn);
  mcb=null;

  return(rtn);
}


/* ---------------------------------------------------------------------------*/
/* S2F50 メッセージ構築及び送信 --------------------------------------------- */

static private int
SendS2F50(
int		did,
int		xid)
{
  TDSMssg	mcb =new TDSMssg();
  byte		hd[]=new byte[12],msg[]=new byte[256];
  byte		vb[]=new byte[32];
  String	str;
  int		rtn,sf=0x0200+50,len;
  
  str=String.format("LOTID (%04d)"		,++cnt250);

		mcb._TDSMssgInit   (0,msg, 256);		// S2F50
		mcb._TDSMssgBuild  (0,msg, 000,  2);		// L2
  vb[0]=0;	mcb._TDSMssgBuild  (0,msg, 010,  1,vb);		//  HCACK
		mcb._TDSMssgBuild  (0,msg, 000,  2);		//  L2
  		mcb._TDSMssgBuild  (0,msg, 020,  5,"PODID");	//   PODID
  		mcb._TDSMssgBuild  (0,msg, 020, 20,str);	//   LOTID
  len=		mcb._TDSMssgEnd    (0,msg);

  if(len<0)	rtn=len;
  else{
    if(FUNC_TYPE==0)	rtn=SAcb._TDSCommSend(0x0000,did,sf,xid,msg,len,hd);
    else		rtn=UAcb._TDSUDrvSend(0x0000,did,sf,xid,msg,len,hd);
  }
  DispData(2,hd,did,sf,rtn,msg,len,rtn);
  mcb=null;

  return(rtn);
}


/* ========================================================================== */
/* S6F11 メッセージ構築及び送信 --------------------------------------------- */

static private int
SendS6F11()
{
  TDSMssg	mcb =new TDSMssg();
  byte		hd[]=new byte[12],msg[]=new byte[256];
  short		vs[]=new short[4];
  int		rtn,sf=0x8600+11,len;

  if((++cnt611)==32768) cnt611=0;

		mcb._TDSMssgInit   (0,msg, 256);		// S6F11
  		mcb._TDSMssgBuild  (0,msg, 000,  3);		// L3
  vs[0]=(short)cnt611;
		mcb._TDSMssgBuild  (0,msg, 052,  1,vs);		//  DATAID
  vs[0]=8;	mcb._TDSMssgBuild  (0,msg, 052,  1,vs);		//  CEID
  		mcb._TDSMssgBuild  (0,msg, 000,  3);		//  L3
  		mcb._TDSMssgBuild  (0,msg, 020, 16,"DATA1");	//   DATA1
  		mcb._TDSMssgBuild  (0,msg, 020, 16,"DATA2");	//   DATA2
  		mcb._TDSMssgBuild  (0,msg, 020, 14,"YYYYMMDDhhmmss");
						// @TIME (本当は現在時刻を設定
						// するのだが、省略。
  len=		mcb._TDSMssgEnd    (0,msg);

  if(len<0)	rtn=len;
  else{
    if(FUNC_TYPE==0)	rtn=SAcb._TDSCommSend(0x0000,0,sf,  0,msg,len,hd);
    else		rtn=UAcb._TDSUDrvSend(0x0000,0,sf,  0,msg,len,hd);
  }
  DispData(2,hd,0x00,sf,rtn,msg,len,rtn);
  mcb=null;

  return(rtn);
}



/* ---------------------------------------------------------------------------*/
/* S6F12 メッセージ構築及び送信 --------------------------------------------- */

static private int
SendS6F12(
int		did,
int		xid)
{
  TDSMssg	mcb =new TDSMssg();
  byte		hd[]=new byte[12],msg[]=new byte[256];
  byte		vb[]=new byte[32];
  int		rtn,sf=0x0600+12,len;

		mcb._TDSMssgInit (0,msg, 256);			// S6F12
  vb[0]=0;	mcb._TDSMssgBuild(0,msg, 010,  1);		// ACKC
  len=		mcb._TDSMssgEnd  (0,msg);

  if(len<0)	rtn=len;
  else{
    if(FUNC_TYPE==0)	rtn=SAcb._TDSCommSend(0x0000,did,sf,xid,msg,len,hd);
    else		rtn=UAcb._TDSUDrvSend(0x0000,did,sf,xid,msg,len,hd);
  }
  DispData(2,hd,did,sf,rtn,msg,len,rtn);
  mcb=null;

  return(rtn);
}



/* ========================================================================== */
/* Callback 関数 ============================================================ */

static private int
CBRecvProc(
int		req,		// i  : ライブラリへの要求コード
int		rtn,		// i  : ライブラリからの戻り値
int		did,		// i  : SECS メッセージのデバイスＩＤ
int		xsf,		// i  : SECS メッセージのＳＦコード
int		xid,		// i  : SECS メッセージのトランザクションＩＤ
byte		xhd[],		// i  : SECS メッセージ・ヘッダ
byte		xmsg[])		// i  : SECS メッセージ
{
  DispData(1,xhd,did,xsf,xid,xmsg,rtn,rtn);
  if(req== 0 && rtn>=0){
    if     (xsf==(0x8100+ 1)&&OType==0)	SendS1F2H (did,xid);
    else if(xsf==(0x8100+ 1)&&OType==1)	SendS1F2E (did,xid);
    else if(xsf==(0x8200+49))		SendS2F50 (did,xid);
    else if(xsf==(0x8600+11))		SendS6F12 (did,xid);
  }

  return(0);
}



/* -------------------------------------------------------------------------- */

static class RecvProcThread extends Thread{
public void
run()
{
  byte		msg[]=new byte[1024],hd[]=new byte[12];
  int		xid[]=new int[ 1],did[]=new int[1],sf[]=new int[1];
  int		rtn,req;

  for(;Break==0;){
    req=0;
    if(FUNC_TYPE==0)	rtn=SAcb._TDSCommRecv(0,did,sf,xid,msg,1024,hd);
    else		rtn=UAcb._TDSUDrvRecv(0,did,sf,xid,msg,1024,hd);
    if(rtn==(-951)){
      Sleep(100);
    }else{
      if((-1000)<rtn && rtn<(-959))	req=(-rtn)-900;
      CBRecvProc(req,rtn,did[0],sf[0],xid[0],hd,msg);
  } }
}
}



/* ========================================================================== */
/* Main 処理 ---------------------------------------------------------------- */

public static void
main(
String[]		argv)
{
  if     (argv.length<1)		printf("Usage: JavaIo {h|e}\n");
  else if(argv[0].equals("h")==false &&
	  argv[0].equals("e")==false)	printf("Usage: JavaIo {h|e}\n");
  else{
    if(argv[0].equals("h")==true)	Host ();
    else				Equip();
  }
}



/* ========================================================================== */
/* ホスト側処理 ------------------------------------------------------------- */

static private void
Host()
{
  BufferedReader	in;
  RecvProcThread	th;
  String		str;
  byte			hd[]=new byte[12],msg[]=new byte[1024];
  int			xid[]=new int[1],did[]=new int[1],sf[]=new int[1];
  int			req,rtn,mno,dsd=0,xsd=0;

  OType=0;	Break=0;
  in=new BufferedReader(new InputStreamReader(System.in));

L0:{
  if(FUNC_TYPE	==0)	SAcb=new TDSComm();
  else			UAcb=new TDSUDrv();
  if(FUNC_TYPE	==0)	rtn=SAcb._TDSCommOpen(0x02,PARAMFILE,"HOST");
  else			rtn=UAcb._TDSUDrvOpen(0x02,PARAMFILE,"HOST",UDRV_MASK);
  if(rtn						< 0)	break L0;
  printf("(H) Opened\n");

  if(USE_CALLBACK!=0){
    th=new RecvProcThread();
    th.start();
  }

  for(;;){		rtn=0;
    if(USE_CALLBACK==0)	str="Req (0:Exit 1:Recv 2:Send) : ";
    else		str="Req (0:Exit 2:Send) : ";
    req=ReadInt(in,str,10);
    if      (req==0){						break;

    }else if(req==1){
      if(FUNC_TYPE==0)	rtn=SAcb._TDSCommRecv(0,did,sf,xid,msg,1024,hd);
      else		rtn=UAcb._TDSUDrvRecv(0,did,sf,xid,msg,1024,hd);
      if(rtn	>=0){	dsd=did[0];	xsd=xid[0];}
      DispData(1,hd,did[0],sf[0],xid[0],msg,rtn,rtn);

    }else if(req==2){
      if(USE_CALLBACK==0) str="Message(1:S1F1 2:S2F49  6:S1F2 7:S6F12) : ";
      else		  str="Message(1:S1F1 2:S2F49) : ";
      mno=ReadInt(in,str,10);
      switch(mno){
	case 1: rtn=SendS1F1 ();		break;
	case 2: rtn=SendS2F49();		break;
	case 6: rtn=SendS1F2H(dsd,xsd);		break;
	case 7: rtn=SendS6F12(dsd,xsd);		break;
    } }
    if(rtn<(-999) || ((-900)<rtn && rtn<0)){
      printf("(H) I/O Error (%d)\n"	,rtn);
  } }
  }	// L0:

  Break=1;
  if(SAcb!=null) SAcb._TDSCommClose(0);		SAcb=null;
  if(UAcb!=null) UAcb._TDSUDrvClose(0);		UAcb=null;
  if(rtn< 0)	   printf("(H) Error (%d)\n"	,rtn);
}



/* ========================================================================== */
/* 装置側処理 --------------------------------------------------------------- */

static private void
Equip()
{
  BufferedReader	in;
  RecvProcThread	th;
  String		str;
  byte			hd[]=new byte[12],msg[]=new byte[1024];
  int			xid[]=new int[1],did[]=new int[1],sf[]=new int[1];
  int			req,rtn,mno,dsd=0,xsd=0;

  OType=1;	Break=0;
  in=new BufferedReader(new InputStreamReader(System.in));

L0:{
  if(FUNC_TYPE	==0)	SAcb=new TDSComm();
  else			UAcb=new TDSUDrv();
  if(FUNC_TYPE	==0)	rtn=SAcb._TDSCommOpen(0x02,PARAMFILE,"EQUIP");
  else			rtn=UAcb._TDSUDrvOpen(0x02,PARAMFILE,"EQUIP",UDRV_MASK);
  if(rtn							< 0) break L0;
  printf("(E) Opened\n");

  if(USE_CALLBACK!=0){
    th=new RecvProcThread();
    th.start();
  }

  if(SECS_MODE!=0 && FUNC_TYPE==0){		// HSMS で TDSComm 使用の場合
    if(SAcb._TDSCommSend(0x0100,0,0,0,msg,0,hd)			< 0) break L0;
    printf("(E) Connected\n");
    if(SAcb._TDSCommSend(0x0200,0,0,0,msg,0,hd)			< 0) break L0;
    printf("(E) Selected\n");
  }

  for(;;){		rtn=0;
    if(USE_CALLBACK==0)	str="Req (0:Exit 1:Recv 2:Send) : ";
    else		str="Req (0:Exit 2:Send) : ";
    req=ReadInt(in,str,10);
    if      (req==0){						     break;

    }else if(req==1){
      if(FUNC_TYPE==0)	rtn=SAcb._TDSCommRecv(0,did,sf,xid,msg,1024,hd);
      else		rtn=UAcb._TDSUDrvRecv(0,did,sf,xid,msg,1024,hd);
      if(rtn	>=0){	dsd=did[0];	xsd=xid[0];}
      DispData(1,hd,did[0],sf[0],xid[0],msg,rtn,rtn);

    }else if(req==2){
      if(USE_CALLBACK==0) str="Message(1:S1F1 2:S6F11  6:S1F2 7:S2F50) : ";
      else		  str="Message(1:S1F1 2:S6F11) : ";
      mno=ReadInt(in,str,10);
      switch(mno){
	case 1: rtn=SendS1F1 ();		break;
	case 2: rtn=SendS6F11();		break;
	case 6: rtn=SendS1F2E(dsd,xsd);		break;
	case 7: rtn=SendS2F50(dsd,xsd);		break;
    } }
    if(rtn<(-999) || ((-900)<rtn && rtn<0)){
      printf("(E) I/O Error (%d)\n"	,rtn);
  } }

  if(SECS_MODE!=0){				// HSMS 接続の場合
  // Deselect request は行わない。（SEMI では HSMS-SS において、Deselect request
  // は行ってはならない、としている。）
  //if(FUNC_TYPE==0)	rtn=SAcb._TDSCommSend(0x0800,0,0,0,msg,0,hd);
  //else		rtn=UAcb._TDSUDrvSend(0x0800,0,0,0,msg,0,hd);
  //if(rtn							< 0) break L0;
  //printf("(E) Deselected\n");
    if(FUNC_TYPE==0)	rtn=SAcb._TDSCommSend(0x0900,0,0,0,msg,0,hd);
    else		rtn=UAcb._TDSUDrvSend(0x0900,0,0,0,msg,0,hd);
    if(rtn							< 0) break L0;
    printf("(E) Separate\n");
  }
  }	// L0:

  Break=1;
  if(SAcb!=null) SAcb._TDSCommClose(0);		SAcb=null;
  if(UAcb!=null) UAcb._TDSUDrvClose(0);		UAcb=null;
  if(rtn< 0)	   printf("(H) Error (%d)\n"	,rtn);
}

}
